---
type: api
title: Create a live query
description: **Spaces method and path for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana/v8/operation/operation-osquerycreatelivequery
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana/v8/operation/operation-osquerycreatelivequery
products:
  - Kibana
---

# Create a live query

- Server: `https://{kibana_url}`

## Paths

- `POST` `/api/osquery/live_queries`
- `POST` `/s/{space_id}/api/osquery/live_queries`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/kibana/v8/authentication#apikeyauth)
- [Basic auth](/elastic/docs-builder/docs/4371/api/doc/kibana/v8/authentication#basicauth)

## Description

Refer to [Spaces](https://www.elastic.co/docs/deploy-manage/manage-spaces) for more information.

Create and run a live query.

## Request Body

`application/json`

- `agent_all` (boolean) — optional
  When `true`, the query runs on all agents.
- `agent_ids` ([] string) — optional
  A list of agent IDs to run the query on.
- `agent_platforms` ([] string) — optional
  A list of agent platforms to run the query on.
- `agent_policy_ids` ([] string) — optional
  A list of agent policy IDs to run the query on.
- `alert_ids` ([] string) — optional
  A list of alert IDs associated with the live query.
- `case_ids` ([] string) — optional
  A list of case IDs associated with the live query.
- `ecs_mapping` (object) — optional
  Map osquery results columns or static values to Elastic Common Schema (ECS) fields
- `event_ids` ([] string) — optional
  A list of event IDs associated with the live query.
- `metadata` (object) — optional — nullable
  Custom metadata object associated with the live query.
- `pack_id` (string) — optional
  The ID of the pack you want to run, retrieve, update, or delete.
- `queries` ([] object) — optional
  An array of queries to run.
  - `ecs_mapping` (object) — optional
    Map osquery results columns or static values to Elastic Common Schema (ECS) fields
  - `id` (string) — optional
    The ID of the query.
  - `platform` (string) — optional
    Restricts the query to a specified platform. The default is all platforms. To specify multiple platforms, use commas. For example, `linux,darwin`.
  - `query` (string) — optional
    The SQL query you want to run.
  - `removed` (boolean) — optional
    Indicates whether the query is removed.
  - `snapshot` (boolean) — optional
    Indicates whether the query is a snapshot.
  - `version` (string) — optional
    Uses the Osquery versions greater than or equal to the specified version string.
- `query` (string) — optional
  The SQL query you want to run.
- `saved_query_id` (string) — optional
  The ID of a saved query.

## Response

OK

`application/json`

Type: `object`

## Code Examples

#### Console

```console
POST /api/osquery/live_queries
```

#### curl

```curl
curl -X POST "https://{kibana_url}/api/osquery/live_queries"
```

